--Dynamic DataMasking SQL Server 2016 TSQL
USE AdventureWorks
GO

CREATE USER DDMUser WITHOUT LOGIN;  
GRANT SELECT ON [Person].[EmailAddress]  TO DDMUser;
GRANT SELECT ON  [Production].[Product]  TO DDMUser;

ALTER TABLE [Person].[EmailAddress] 
ALTER COLUMN emailaddress ADD MASKED WITH (FUNCTION = 'email()')

EXECUTE AS USER = 'DDMUser';  
SELECT * FROM [Person].[EmailAddress] ;  
REVERT;

ALTER TABLE [Person].[EmailAddress] 
ALTER COLUMN emailaddress ADD MASKED WITH (FUNCTION = 'default()')

EXECUTE AS USER = 'DDMUser';  
SELECT * FROM [Person].[EmailAddress] ;  
REVERT;

ALTER TABLE [Production].[Product]
ALTER COLUMN StandardCost ADD MASKED WITH (FUNCTION = 'random(1,12)')

EXECUTE AS USER = 'DDMUser';  
SELECT * FROM [Production].[Product] ;  
REVERT;

	
GRANT UNMASK TO DDMUser
GO

EXECUTE AS USER = 'DDMUser';  
SELECT * FROM [Person].[EmailAddress] 
SELECT * FROM [Production].[Product] ;  
REVERT;


REVOKE UNMASK TO DDMUser
GO

ALTER TABLE [Production].[Product]
ALTER COLUMN ProductNumber ADD MASKED WITH (FUNCTION = 'partial(2,"1adfshga;slkdhg;askdhg;alskd23",2)')

EXECUTE AS USER = 'DDMUser';  
SELECT * FROM [Production].[Product] ;  
REVERT;
	
SELECT T1.name as TableName,T2.NAME ColumnName, T2.is_masked IsMasked, T2.masking_function MaskFunction  
FROM sys.masked_columns AS T2 
JOIN sys.tables AS T1   
ON T2.object_id = T1.object_id  
WHERE is_masked = 1;   

ALTER TABLE [Person].[EmailAddress] 
ALTER COLUMN emailaddress DROP MASKED 
GO
ALTER TABLE [Production].[Product]
ALTER COLUMN StandardCost DROP MASKED
GO
ALTER TABLE [Production].[Product]
ALTER COLUMN ProductNumber DROP MASKED

DROP USER DDMUser